.\" ditroff -man
.\" RCS $Id: xon-xoff.nr,v 14.27.0.1 1993/07/30 13:27:15 tom Exp tom $
.hy 0
.TH XON-XOFF 1 "14 August 1992"
.ad
.SH NAME
.BR xon-xoff " \- check the terminal's need for flow control"
.SH SYNOPSYS
.RI "xon-xoff [\-f] [\-s] [" "pad time in ms" "] [" "pad char" "]"
.SH DESCRIPTION
This program checks if the terminal can handle output at the current
tty line speed, without having to rely on Xon-Xoff synchronization.
It does so by writing a bunch of pad characters to standard error, then
waiting to see if the terminal generates any ^Q or ^S characters.
Depending on your system, this check can take from half a second to
up to 2 seconds.

If the environment variable XONXOFF exists, and the 
.B -f
option is
.I not
given, the physical check is bypassed and the value of this 
variable is used to determine the result:
.sp
.in +5
.nf
XONXOFF=0 \- if no Xon-Xoff synchronisation is needed,
XONXOFF=1 \- if Xon-Xoff synchronisation is mandatory,
.fi
.in -5
.sp
If the
.B -s
option is given, a shell command to set this environment
variable is generated.  Thus you can use the command:
.sp
.in +5
eval `xon-xoff \-s`
.in -5
.sp
in your shell startup file to initialize XONXOFF.
.br
(JOVEs system .joverc checks this to set "allow-^Q-and-^S").

The default pad time is 500 milliseconds (based on the terminal's
advertised speed); the default pad character is NUL.
.SH OPTIONS
.TP
.B \-f
force check (irrespective of the value of XONXOFF).
.TP
.B \-s
output shell command to setenv XONXOFF variable.
.SH RESULTS
.nf
EXIT_SUCCESS	\- if no Xon-Xoff synchronisation is needed,
EXIT_FAILURE 	\- if Xon-Xoff synchronisation is mandatory,
2		\- usage error.
.fi
.SH AUTHOR
Tom Hageman (tom@basil.icce.rug.nl)
.SH BUGS
Should take default pad character from termcap(5).
.ig
.\"=====================================================================
.\" $Log: xon-xoff.nr,v $
.\" Revision 14.27.0.1  1993/07/30  13:27:15  tom
.\" fix spacing in some .nr directives to get it through groff without warnings.
.\"
.\" Revision 14.27  1992/09/13  23:06:52  tom
.\" some minor formatting changes.
.\"
.\" Revision 14.26  1992/08/26  23:57:14  tom
.\" add RCS directives.
.\"
.\"=====================================================================
..
