########################################################################
# This program is Copyright (C) 1986 by Jonathan Payne.  JOVE is       #
# provided to you without charge, and with no warranty.  You may give  #
# away copies of JOVE, including sources, provided that this notice is #
# included in all the files.					       #
########################################################################
# Modified: 1988-1991 Tom Hageman	(Makefile for Atari ST)
#
# Atari ST Turbo C version (using TRH modified/extended libraries and gulam)
#
# NOTA BENE: The installation procedure is changed.  Now, run
#   "make install"
# to install executables + system .jove-sys.rc only, and
#   "make INSTALL"
# to install everything, including online help and manuals.
#
# If you add/modify/delete commands or variables to JOVE, run
#   "make newdef"
# to update the definition list (or touch the Makefile).
# To force an install of the executables, run
#   "make force install"

# WARNING: some entries in this makefile do not work properly unless your
# make program and shell support some kind of `extended command line' protocol.

RCSid	= $$Id: makefile.st,v 14.32.0.9 1994/02/04 21:48:50 tom Exp tom $$

# What are we for?
PROG	= jove
VERSION	= 5.00


# BIN, INC and LIB are defined within make's default rules and symbols
# as is CC, but CC is overruled here.

CC	= $(BIN)tcc.ttp -I$(INC)x -I$(INC)
#CC	= gcc -mshort -c
#LD	= gcc -mshort

# additional compiler flags
# (TC before v1.1c can't use -A due to some bad definitions in <aes.h>)
CC-FLAGS = -A -G -P -K -w-pia -w-rvl#	Turbo C
#CC-FLAGS = -funsigned-char#		gcc

# compiler optimize flag (only if optimization bugs are to be avoided)
CC-OPT	=

# compiler flag for small programs
CC-P	= -P-#	Turbo C
#CC-P	= #	gcc

# compiler flag for object-file redirection
CC-O	= -o=#	Turbo C
#CC-O	= -o #	gcc

# program suffixes.
o = .o
x = .ttp
X = .tos
sys = .st
# dirsep character.
/ = \\

# These are arguments to `makevsn' and show up in JOVEs "version" command.
# If you don't like the defaults generated by `makevsn', you can override
# them here.

WHO	= -W TRH		# that's me
#VSN	= -V $(VERSION)		# based on Jon's 4.6, upgraded to 4.14
#SYSNAME = -S "Atari ST"	# `pretty' system/site name.
#DATE	= -D dd-Mmm-yy		# lie about the installation date.

MAKEVSN	= .$/makevsn $(WHO) $(VSN) $(SYSNAME) $(DATE)

# location of the documentation sources.
DOC	= doc$/

# rm command (usually "rm -f" or just "rm")
RM	= rm -f

# sed command (usually "sed")
SED	= sed

# cdiff command (usually "diff -c" or "cdiff")
CDIFF	= diff -c2
# CDIFF	= cdiff -c2

# ctags command (newer ctags have sense of -t reversed)
# CTAGS	= ctags -t	# old ctags: include typedefs
# CTAGS	= ctags -d	# new ctags: dont't exclude typedefs, allow duplicates
CTAGS	= ctags -dt	# gnu ctags: include typedefs + defines.

# install command (poor man's BSD-like "install")
INSTALL	= .$/_install$x

# worker command for "make depend".  Sadly this is compiler-dependent.
#  -> This is for Gnu C (gcc) which does its formatting itself:
MAKEDEP = ${CC} -MM $(CFLAGS) $(SOURCES) >$@.@@@;\
	${SED} -e '/\.*\/*vars\.h */s/// $@.@@@'


# TMPDIR is where the tmp files get stored, usually /tmp.
# LIBDIR is for online documentation, RECOVER, and the system-wide .joverc file.
# BINDIR is where to put the executables JOVE and TEACHJOVE.
# MANDIR is where the manual pages go for JOVE and TEACHJOVE.
# MANEXT is the extension for the man pages, e.g., jove.1 or jove.l or jove.m.
# In DESTDIR you can supply a common base directory e.g., for experimental
# versions of JOVE.

DESTDIR =
TMPDIR = d:$/tmp
LIBDIR = d:$/jove
BINDIR = c:$/bin
MANDIR = c:$/man$/man$(MANEXT)
MANEXT = 1

# These should all just be right if the above ones are.
JOVE		= $(DESTDIR)$(BINDIR)$/jove$x
RECOVER		= $(DESTDIR)$(LIBDIR)$/recover$x
JOVE_RECOVER	= $(DESTDIR)$(BINDIR)$/jove_recover$x
TEACHJOVE	= $(DESTDIR)$(BINDIR)$/teachjove.g
JOVERC		= $(DESTDIR)$(LIBDIR)$/jove-sys.rc
JOVE.HLP	= $(DESTDIR)$(LIBDIR)$/jove.hlp
TEACH-JOVE	= $(DESTDIR)$(LIBDIR)$/teach-jove
JOVEM		= $(DESTDIR)$(MANDIR)$/jove.$(MANEXT)
TEACHJOVEM	= $(DESTDIR)$(MANDIR)$/teachjove.$(MANEXT)
EXTRA.HLP	= $(DESTDIR)$(LIBDIR)$/extrahlp.st
KEYSUBST	= $(DESTDIR)$(LIBDIR)$/keysubst$x
JOVEABBR	= $(DESTDIR)$(LIBDIR)$/joveabbr
NEWS		= $(DESTDIR)$(LIBDIR)$/News
PICKCHAR	= $(DESTDIR)$(LIBDIR)$/pickchar.jc

# Which JOVE to make ("xjove$x" is the only option at the moment)

XJOVE	= xjove$x

# Debug/optimize flags for CC and LD
# (debug option -y available only for TC v2.0 and later)

DEBUG	= -y#		Turbo C
LDEBUG	= -y -l
#DEBUG	= -O# -g#	 gcc
#LDEBUG	= $(DEBUG)

# This is the linker control file option for XJOVE.
JOVE-LNK = -c=jovest.lnk#	Turbo C
#JOVE-LNK = version$o $(OBJECTS)#		gcc

# Select the right libraries for your system.

LIBS	= $(LIB)gem.lib $(LIB)lna.lib $(LOADLIBES)
#LIBS	= -lgem
#LOAD1ST =
#LOADLIBES =

LDFLAGS = $(LDEBUG)

# Select the right system identifier

SYSTEM	= ATARIST

# other options: LISP, PERL, COLOR, GEMINI, and LOCAL (to include "Local.h")

OPTIONS	= -DGEMINI -DTRH -DCOLOR -DPERL

CFLAGS_NOOPT = $(CC-FLAGS) \
	$(OPTIONS) $(DEBUG) -D$(SYSTEM)
CFLAGS	= $(CFLAGS_NOOPT) $(CC-OPT)

# Where def-list should depend on.  (Actually it depends on all JOVE sources,
# but you may find this too expensive.  If you undefine this you can still
# force an update of def-list with the command "make newdef")

#DEFLISTDEP = $(JOVEALL)

# Chartable support
CTABLE = atarist

# shorthand for chartable directory
C = chartabs
CT = $C$/$(CTABLE)

#==============================================================================

O1 = tune$o keymaps$o funcdefs$o abbrev$o ask$o buf$o c$o case$o ctype$o
O2 = delete$o dirs$o disp$o extend$o fkeys$o fp$o insert$o io$o iproc$o
O3 = jove$o macros$o malloc$o marks$o maps$o misc$o move$o para$o
O4 = proc$o re$o rec$o scandir$o screen$o search$o table$o term$o
O5 = tty$o util$o vars$o wind$o fmt.o atari_st$o last$o
OBJECTS = $(O1) \
	$(O2) \
	$(O3) \
	$(O4) \
	$(O5)

S1 = funcdefs.c abbrev.c ask.c buf.c c.c case.c ctype.c delete.c
S2 = dirs.c disp.c extend.c fp.c fmt.c fkeys.c insert.c io.c iproc.c
S3 = jove.c last.c macros.c malloc.c marks.c maps.c misc.c move.c para.c
S4 = proc.c re.c rec.c scandir.c screen.c search.c table.c term.c
S5 = tty.c util.c vars.c version.c wind.c
JOVESRC = $(S1) \
	 $(S2) \
	 $(S3) \
	 $(S4) \
	 $(S5)

# these files are "included". They are NOT standalone sources!
JOVEINC = ipr-pty.ci ipr-pipe.ci mouse.ci

# the system-dependent and `meta' source files.
JOVEOTHER = $(ATARIST-SRC) $(MSDOS-SRC)	$(VMS-SRC) $(MAC-SRC) \
	tune.ct keymaps.ct

# all JOVE sources.
JOVEALL = $(JOVESRC) $(JOVEINC) \
	$(JOVEOTHER)

HEADERS = ctype.h jove.h io.h maps.h process.h re.h readdir.h rec.h \
	screen.h table.h temp.h termcap.h tune.h tty.h  \
	portansi.h portdefs.h

SOURCES = $(JOVEALL) kbd.c portsrv.c recover.c setmaps.c makevsn.c keysubst.c \
	_install.c xon-xoff.c ctime.c

DOCS-TEX = $(DOC)jove.ltx $(DOC)joveman.tex $(DOC)jovecmds.tex \
	$(DOC)a4.sty $(DOC)tocfix.sty $(DOC)medieval.sed $(DOC)detexcmd.sed \
	$(DOC)nicekeys.sed $(DOC)upd-bind.awk \
	$(DOC)make-tex $(DOC)derofcmd.jc $(DOC)mklists.jc $(DOC)sort-hlp.jc \
	$(DOC)usedonly.jc $(DOC)teach-jove $(DOC)News $(DOC)jove.qref \
	$(DOC)jove.nr $(DOC)teachjove.nr $(DOC)xon-xoff.nr

EXAMPLES = $(DOC)extrahlp.* $(DOC)sys-*.rc $(DOC)example.rc $(DOC)example.abr \
	$(DOC)pickchar.jc $(DOC)unshar.jc $(DOC)srcsplit.jc

MISC =	makefile.ux Makedep Whatsnew README \
	if.sed refs.sed vars.sed jove.rc

AUX = tags def-list vars.h vars.inc funcs.inc refs.inc

BACKUPS = $(HEADERS) $(SOURCES) $(MISC) $(ATARIST-FILES) $(MSDOS-FILES) \
	$(MAC-FILES) $(VMS-FILES)

ATARIST-SRC = atari_st.c
ATARIST-FILES = jinstall.c jinstall.inf makefile.st

MSDOS-SRC = msdos.c
MSDOS-FILES = makefile.dos

MAC-SRC = mac.c menumaps.ct
MAC-FILES = mjovers.Hqx

VMS-SRC = vms.c ipr-vms.ci
VMS-FILES = makefile.vms

DOCS = DOCS-NROFF DOCS-TEX EXAMPLES

EXECUTABLES = $(XJOVE) recover$x keysubst$x jinstall$X

DONE =	@-${MAKEVSN} '**** Completed at: %U'

all:	start ident $(EXECUTABLES)
	${DONE}

.PRECIOUS: $(EXECUTABLES)

# Make sure the makefile is up to date before we do anything serious.
start:	Makefile $(DOC)L-patch.make makevsn$x
	@-${MAKEVSN} '**** Started at: %U'

ident:	makevsn$x
	@-${MAKEVSN} '**** $(XJOVE): version %V, system "%S", installed by "%W"'

xjove$x:	$(OBJECTS) version$o jovest.lnk
	-${LD} $(CC-O)$(XJOVE) $(LDFLAGS) $(LOAD1ST) $(JOVE-LNK) $(LIBS)

jovest.lnk: Makefile
	@echo '-s=16384' version$o $(OBJECTS) >$@

recover$x:	recover$o tune$o
	-${LD} $(LDFLAGS) $(CC-O)$@ $(LOAD1ST) recover$o tune$o $(LOADLIBES)

recover$o:	recover.c rec.h temp.h tune.h Makefile
	${MAKE} -$(MAKEFLAGS) version.h
	${CC} $(CFLAGS) $(CC-P) recover.c

jinstall$X:	jinstall.c tune.c
	${CC} $(CFLAGS) $(CC-P) jinstall.c
	-${LD} $(LDFLAGS) $(CC-O)$@ $(LOAD1ST) jinstall$o $(LOADLIBES)

makevsn$x:	makevsn.c
	${CC} $(CFLAGS) $(CC-P) $?
	-${LD} $(CC-O)$@ $(LOAD1ST) makevsn$o $(LOADLIBES)

keysubst$x:	keysubst.c
	${CC} $(CFLAGS) $(CC-P) $?
	-${LD} $(CC-O)$@ $(LOAD1ST) keysubst$o $(LOADLIBES)

setmaps$X:	setmaps$o
	-${LD} $(LDFLAGS) $(CC-O)$@ $(LOAD1ST) setmaps$o $(LOADLIBES)

setmaps$o:	setmaps.c funcs.inc vars.inc vars.h tune.h Makefile
	${CC} $(CFLAGS) $(CC-P) setmaps.c

keymaps.c:	setmaps$X keymaps.ct refs.inc
	@echo '/* Changes should be made in keymaps.ct, not to this file! */' >$@
	@echo ' ' >>$@
	.$/setmaps$X keymaps.ct <keymaps.ct >>$@
	@echo "\#line 1 \"refs.inc\"" >>$@ 
	.$/setmaps refs.inc <refs.inc >>$@

keymaps$o:	keymaps.c
	${CC} $(CFLAGS) keymaps.c

version$o:	version.h

version.h:	Makefile makevsn$x $(OBJECTS)
	@${MAKEVSN} >$@

# Create a sorted list containing all information about tabular material
# in JOVE (i.e., variable and command definitions).
# It is built by extracting the "DEF_XXX" macros interspersed in the
# JOVE sources and then sorting it.  The variable and command tables
# (funcs.inc, vars.inc and vars.h, and refs.inc) are derived from it.
# Whenever you add a new variable and/or command definition you should
# run "make newdef" or remove "def-list" prior to compilation.

newdef:
	@${MAKE} 'DEFLISTDEP=$$(JOVEALL)' def-list

def-list:	$(DEFLISTDEP)
	@-mv $@ $@.bak
	@echo '/* This file is created automatically from the JOVE sources by make def-list */' >$@
	@echo '/* !!!!!!!!!!!!!!!!!!!!!!!!DO NOT CHANGE THIS FILE!!!!!!!!!!!!!!!!!!!!!!!!!! */' >>$@
	@echo '/* ALL CHANGES TO THIS FILE WILL BE LOST THE NEXT TIME YOU RUN make def-list */' >>$@
	@echo ' ' >>$@
	${SED} -n -e '/^DEF_/p' $(JOVEALL) >$@.@
	sort '-t"' -u +1 -2 +2 $@.@ >>$@
	@-${RM} $@.@

def-list-targets: keymaps.o funcdefs.o vars.o

auxfiles:	$(AUX)

funcs.inc:	def-list
	${SED} -e '/^DEF_[ISR]/d' -f if.sed $? >$@

vars.inc:	def-list
	${SED} -e '/^DEF_[^IS]/d' -f if.sed $? >$@

vars.h:		vars.inc
	${SED} -f vars.sed $? >$@

refs.inc:	def-list
	${SED} -e '/^DEF_[^R]/d' -f if.sed $? >refs.@
	${SED} -f refs.sed refs.@ >$@
	@-${RM} refs.@

iproc$o:	ipr-pty.ci ipr-pipe.ci ipr-vms.ci

vars$o:		vars.inc

funcdefs$o:	funcs.inc

atari_st$o:	atari_st.c mouse.ci
	${CC} $(CFLAGS) atari_st.c

tune$o:	tune.c
	${CC} $(CFLAGS) tune.c

SUBSTITUTE = cat	# a very poor man's substitute

tune.c: tune.ct
	@echo '/* Changes should be made in tune.ct, not to this file! */' >$@
	@echo ' ' >>$@
	@${SUBSTITUTE} tune.ct >>$@

ctype$o:	ctype.inc

ctype.inc:	$(CT).tab Makefile
	cat $(CT).tab >$@

.SUFFIXES: .dt .tab .ctb
.ctb.tab .dt.tab:
	${MAKE} -$(MAKEFLAGS) -f $C$/Makefile DIR=$C$/ DIFFBASE=$(CT).tab $@

# "touch -c" touches only existing files. {{Minix-specific???}}
force:
	@-touch -c $(EXECUTABLES) $(LOCALS)

install: install_most
	${DONE}
	@-echo '(run "make INSTALL" to install JOVEs on-line help too)'
#	...for people who keep forgetting it ;-)

install_most: start ident $(INSTALL) $(DESTDIR)$(LIBDIR) \
	$(LOCALS) \
	$(JOVE) $(JOVE_RECOVER) $(RECOVER) $(PIPEPROCS) \
	$(JOVERC) $(JOVEABBR)

INSTALL: install_most $(KEYSUBST) $(EXTRA.HLP) \
	$(JOVE.HLP) $(TEACH-JOVE) $(TEACHJOVE) $(NEWS) \
	$(JOVEM) $(TEACHJOVEM) $(XON-XOFFM)
	${DONE}

.$/_install$x: _install.c
	${CC} $(CFLAGS) $?
	-${LD} $(LDFLAGS) $(CC-O)$@ $(LOAD1ST) _install$o $(LOADLIBES)

$(DESTDIR)$(LIBDIR)::
	-mkdir $@

# The "L-xxxxxx" files are template files localized for your system.
# (all files mentioned here are in the DOC subdirectory)
#
#   L-extra.hlp	- Local extra help screens.  If it doesn't exist it is
#		  copied from "extrahlp$(sys)".
#
#   L-abbrev	- Local system-wide abbreviations.  It is made from
# 		  "example.abr", if that exists, to which the contents of
#		  "L-add.abr" are added.
#
#   L-system.rc	- Local system .joverc startup script.  It is made from
#		  "sys-stpc.rc", if that exists, to which the contents of
#		  "L-add.rc" are added and the patches in the context-diff
#		  file "L-patch.rc", if that exists, are applied.
#
LOCALS	= $(DOC)L-abbrev $(DOC)L-extra.hlp $(DOC)L-system.rc \
	$(DOC)L-patch.rc $(DOC)L-add.rc $(DOC)L-patch.make

.PRECIOUS: $(LOCALS) Local.h

$(DOC)L-abbrev: $(DOC)example.abr $(DOC)L-add.abr
	cat $(DOC)example.abr $(DOC)L-add.abr >$@

$(DOC)L-extra.hlp: $(DOC)extrahlp$(sys)
	cp $? $@

$(DOC)L-system.rc: $(DOC)sys-stpc.rc $(DOC)L-add.rc
	cat $(DOC)sys-stpc.rc $(DOC)L-add.rc >$@@
	-patch -N $@@ $(DOC)L-patch.rc
	-mv $@@ $@
	-${CDIFF} $(DOC)sys-stpc.rc $@ >$(DOC)L-patch.rc

$(DOC)example.abr $(DOC)sys-stpc.rc:
	@set status 0
	# emulation of "true"

$(DOC)L-add.abr $(DOC)L-add.rc:
	@touch $@


$(TEACH-JOVE): $(DOC)teach-jove
	${INSTALL} -c -m 644 $? $@

$(DOC)jove.hlp: $(DOC)jovecmds.tex $(DOC)detexcmd.sed $(DOC)derofcmd.jc
	${SED} -e '/^\#/d' -e '/^[	 ]*$$/d' $(DOC)detexcmd.sed >$(DOC)detexcmd.@@@
	${SED} -f $(DOC)detexcmd.@@@ $(DOC)jovecmds.tex >$@
	jove -j $@ +j $(DOC)derofcmd.jc
	jove -j $@ +j $(DOC)usedonly.jc
	@-mv Missing Rejected $(DOC)

$(JOVE.HLP): $(DOC)jove.hlp
	${INSTALL} -c -m 644 $? $@

$(EXTRA.HLP): $(DOC)L-extra.hlp
	${INSTALL} -c -m 644 $? $@

$(JOVERC): $(DOC)L-system.rc
	@cp $@ $(DOC)L-system.bak
	@echo '(Original system joverc saved as "$(DOC)L-system.bak")'
	@${SUBSTITUTE} $? >$?@
	${INSTALL} -m 644 $?@ $@

MAKELINK = ${INSTALL} -c -m 755 $? $@

$(KEYSUBST): keysubst$x
	${INSTALL} -c -s -m 755 $? $@

$(RECOVER): $(JOVE_RECOVER)
	${MAKELINK}
$(JOVE_RECOVER): recover$x
	${INSTALL} -c -s -m 755 $? $@

$(JOVE): $(XJOVE)
	${INSTALL} -c -s -m 755 $? $@

$(TEACHJOVE): Makefile
	@echo "jove -teach" >teachjove.@
	${INSTALL} -m 755 teachjove.@ $@

$(JOVEABBR): $(DOC)L-abbrev
	${INSTALL} -c -m 644 $? $@

$(JOVEM): $(DOC)jove.nr
	@${SUBSTITUTE} $? >$?@
	@-${INSTALL} -m 644 $?@ $@

$(TEACHJOVEM): $(DOC)teachjove.nr
	@${SUBSTITUTE} $? >$?@
	${INSTALL} -m 644 $?@ $@

$(XON-XOFFM): $(DOC)xon-xoff.nr
	@${SUBSTITUTE} $? >$?@
	@-${INSTALL} -m 644 $?@ $@

$(NEWS): $(DOC)News
	${INSTALL} -c -m 644 $? $@

$(PICKCHAR): $(DOC)pickchar.jc
	${INSTALL} -c -m 644 $? $@

mkdoc: $(DOC)Makefile
	@cd $(DOC);${MAKE} JOVERC=$(JOVERC) JOVE=$(JOVE) $(MKDOC);cd ..

$(DOC)Makefile: $(DOC)make-tex
	@cp $? $@

echo:
	@echo $(HEADERS) $(SOURCES)

objects:
	@echo version$o $(OBJECTS)

strip:
	strip $(EXECUTABLES)

tags:	$(HEADERS) $(SOURCES)
	-mv tags tags.bak
	${CTAGS} $(HEADERS) $(SOURCES)

.PRECIOUS: Makefile

Makefile:	makefile$(sys)
	cp $? $@.@
	patch -N $@.@ $(DOC)L-patch.make
	@-mv $@ $@.bak
	@echo '(old Makefile is saved in $@.bak)'
	@-mv $@.@ $@
	@echo '*--> Please re-run make with the new Makefile.'
	@false

$(DOC)L-patch.make: Makefile
	-${SED} -n "1,/^\# DO NOT DELETE THIS LINE/p" Makefile >Makefile.@
	-${CDIFF} makefile$(sys) Makefile.@ >$@

CIOPT = -u -d
ciall:
	ci $(CIOPT) $(BACKUPS)

COOPT = -d
coall:
	co $(COOPT) $(BACKUPS)

#	Be careful! ARCs built under unix have case-sensitive file names.
#	Under MS-DOS/TOS we [TRH/GCThW] use a modified ARC program that
#	leaves the names of existing entries intact, and converts names
#	of new entries to lower case!
#
arc:	arc-src arc-tex arc-samp arc-aux arc-locl arc-ctabsrc arc-auxtab #arc-nro

ARCDIR = ..$/
UARC = arc u

arc-src:
	${UARC} $(ARCDIR)jovesrc.arc $(BACKUPS)

arc-aux:
	${UARC} $(ARCDIR)joveaux.arc $(AUX)

arc-tex:
	${UARC} $(ARCDIR)jovetex.arc $(DOCS-TEX)

arc-samp:
	${UARC} $(ARCDIR)jovesamp.arc $(EXAMPLES)

arc-locl:
	${UARC}	$(ARCDIR)jovelocl.arc $(LOCALS) Local.h

arc-ctabsrc arc-auxtab:
	${MAKE} -$(MAKEFLAGS) -f $C$/Makefile DIR=$C$/ 'UARC=$(UARC)' ARCDIR=$(ARCDIR) $@


zip:	zip-src zip-aux zip-locl

ZIPDIR = ..$/
UZIP = zip -our

zip-src:
	${UZIP} $(ZIPDIR)jovesrc $(BACKUPS) $(DOCS-TEX) $(EXAMPLES) \
		$C -x '*.tab' '*.dt' '*%*' '*RCS*' '*.inc'
zip-aux: chartabs-most
	${UZIP} $(ZIPDIR)joveaux $(AUX) $C$/*.tab $C$/*.dt $C$/*.inc
zip-locl:
	${UZIP} $(ZIPDIR)jovelocl $(LOCALS) Local.h

chartabs-most:
	${MAKE} -f $C$/Makefile DIR=$C$/ most


# {Some makes cannot handle "\#" in macro definitions. sigh...}
clean:
	-${RM} \#* *\# $(DOC)\#* $(DOC)*\# $(cleanlist)
cleanlist = \
	a.out core *$o keymaps.c tune.c version.h setmaps *err \
	*.orig *.rej %* *[~@] \
	$(DOC)*.orig $(DOC)*.rej $(DOC)%* $(DOC)*[~@]

CLEAN: clean
	-${RM} $(CLEANlist)
CLEANlist = \
	$(AUX) $(EXECUTABLES) makevsn$x _install$x *.bak \
	$(DOC)*.nro $(DOC)*.dvi $(DOC)*.aux $(DOC)*.toc $(DOC)*.log

pack-arc: arc CLEAN
	${RM} $(BACKUPS) $(DOCS-NROFF) $(DOCS-TEX) $(EXAMPLES) $(LOCALS)

depend:
	${SED} -n "1,/^\# DO NOT DELETE THIS LINE/p" Makefile	 >Makefile.@@@
	${MAKEDEP}						>>Makefile.@@@
	@echo "\# DEPENDENCIES MUST END AT END OF FILE" 	>>Makefile.@@@
	@echo "\# IF YOU PUT STUFF HERE IT WILL GO AWAY"	>>Makefile.@@@
	@echo "\# see make depend above"			>>Makefile.@@@
	mv Makefile Makefile.bak
	mv Makefile.@@@ Makefile
	@echo 'New "Makefile". Old version is in "Makefile.bak".'
	false

# DO NOT DELETE THIS LINE -- make depend uses it
